'*******************************************************************************
'	Filename		: codev_save.vbs
'	Created			: 17 april 2007
'	Created by	: Emmanuel CARNIS
'	Comments		: Saves the active document, and saves the previous version in a 
'								backup file, number attached as a postfix to the file name.
'					  		eg: file.1.vbs
' Update      : v0.2 error handling when saving a new file (Franois RIGUET, 03/2008)
'	You may distribute this script freely, but please keep this header intact.
'*******************************************************************************
Option Explicit

Const MODULE_NAME  = "CodeV_save"
Const MODULE_VER   = "0.2"
Const MODULE_TITLE = "Code V save" 

Dim objFSO
Dim g_strNewFilePath

Sub Init
    addMenuItem "Code V save", "", "CodeV_save", "CTRL+ALT+S"
End Sub

Sub CodeV_save()
	Dim objEditor
	Dim strFilePath, strFilePath_bk, strFileName, strFileName_we, strDirectory, strFileExt
	Dim intVersion
	
	Set objEditor = newEditor()
	Set objFSO = CreateObject("Scripting.FileSystemObject")
	

	With objEditor
		.assignActiveEditor()
		strFilePath 	= .fileName()	' grab the file path of the active document
	End With

		' get directory, filename without extension, and extension
		strDirectory = GetDirectory(strFilePath)
		strFileName = GetFileName(strFilePath)

		On Error Resume Next 
		strFileName_we = Mid(strFileName, 1, InStrRev(strFileName,".")-1)
		If Err.Number <> 0 Then 
			runPSPadAction "aSaveAs" 
			With objEditor
				.assignActiveEditor()
				strFilePath 	= .fileName()	' grab the file path of the active document
			End With
			strDirectory = GetDirectory(strFilePath)
			strFileName = GetFileName(strFilePath)
			strFileName_we = Mid(strFileName, 1, InStrRev(strFileName,".")-1)
		End If 
		On Error GoTo 0 
		strFileExt = Mid(strFileName,InStrRev(strFileName,"."))

		intVersion = 0
		
		do
			intVersion = CInt(intVersion) + 1
			strFilePath_bk = strDirectory & strFileName_we & "." & intVersion & strFileExt 
		loop while objFSO.FileExists(strFilePath_bk)  
		
	objFSO.copyFile strFilePath, strFilePath_bk
	
	With objEditor
		.assignActiveEditor()
		.saveFile()
	End With
	
	
	Set objFSO = Nothing	
	Set objEditor = Nothing

End Sub


Function GetDirectory(strPath)
	If Len(strPath) = 0 Then Exit Function				 ' input string is empty
	strPath = Replace(strPath, Chr(47), Chr(92))		 ' convert backslashes to forward slashes
	If InStr(1, strPath, Chr(92)) = 0 Then Exit Function ' string contains no forward slashes
	GetDirectory = Left(strPath, InStrRev(strPath, Chr(92)))
End Function

Function GetFileName(strPath)
	If Len(strPath) = 0 Then Exit Function				' input string is empty
	strPath = Replace(strPath, Chr(47), Chr(92))		' convert backslashes to forward slashes
	If InStr(strPath, Chr(92)) = 0 Then Exit Function	' string contains no forward slashes
	If Right(strPath, 1) = Chr(92) Then Exit Function	' path contains no file name
	GetFileName = Right(strPath, Len(strPath) - InStrRev(strPath, Chr(92)))
End Function
